
#ifndef PLS_DATAFLOW_INTERNAL_INPUTS_H_
#define PLS_DATAFLOW_INTERNAL_INPUTS_H_

#include <tuple>

#include "input.h"

namespace pls {
namespace dataflow {
namespace internal {

template<int P, typename ...I>
class inputs {
  using values_type = std::tuple<input<I>...>;
  values_type values_;

 public:
  template<int N>
  typename std::tuple_element<N, values_type>::type &get() {
    return std::get<N>(values_);
  }
};

}
}
}

#endif //PLS_DATAFLOW_INTERNAL_INPUTS_H_
